---
- name: Clone git repo
  ansible.builtin.git:
    force: true
    repo: "{{ git2bunny_repo }}"
    dest: "{{ git2bunny_tmp }}/git2bunny_{{ inventory_hostname }}"
    version: "{{ git2bunny_repo_ref }}"
  delegate_to: 127.0.0.1
  become: false
  when: git2bunny_enabled|bool
  register: result
  retries: 10
  delay: 10
  until: result is not failed
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny

- name: Build
  ansible.builtin.command: "{{ git2bunny_command }}"
  args:
    chdir: "{{ git2bunny_tmp }}/git2bunny_{{ inventory_hostname }}"
  delegate_to: 127.0.0.1
  become: false
  when: git2bunny_enabled|bool and git2bunny_command != ""
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny

- name: Cleanup build directory before deploy
  ansible.builtin.file:
    state: absent
    path: "{{ git2bunny_tmp }}/git2bunny_{{ inventory_hostname }}/{{ git2bunny_dist }}/{{ item }}"
  with_items: "{{ git2bunny_exclude }}"
  delegate_to: 127.0.0.1
  become: true
  when: git2bunny_enabled|bool
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny

- name: Get files list
  ansible.builtin.find:
    path: "{{ git2bunny_tmp }}/git2bunny_{{ inventory_hostname }}/{{ git2bunny_dist }}/"
    file_type: any
    recurse: true
  register: files
  delegate_to: 127.0.0.1
  become: false
  when: git2bunny_enabled|bool
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny

- name: Register git2bunny replace path
  ansible.builtin.set_fact:
    git2bunny_replace: "{{ git2bunny_tmp }}/git2bunny_{{ inventory_hostname }}/{{ git2bunny_dist }}"
  delegate_to: 127.0.0.1
  become: false
  when: git2bunny_enabled|bool
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny

- name: Upload
  ansible.builtin.uri:
    url: "{{ git2bunny_url }}/{{ item.path | replace(git2bunny_replace, '') }}"
    method: PUT
    src: "{{ item.path }}"
    status_code: [200, 201]
    headers:
      AccessKey: "{{ git2bunny_accesskey }}"
  loop: "{{ files.files }}"
  delegate_to: 127.0.0.1
  become: false
  when: git2bunny_enabled | bool and not item.isdir | bool
  register: result
  retries: 10
  delay: 10
  until: result is not failed
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny

- name: Remove temporary dir
  ansible.builtin.file:
    state: absent
    path: "{{ git2bunny_tmp }}/git2bunny_{{ inventory_hostname }}"
  delegate_to: 127.0.0.1
  become: false
  when: git2bunny_enabled|bool
  tags:
    - setup-all
    - setup-git2bunny
    - install-all
    - install-git2bunny
